
Infrastructure - Task #7910

Story # 7832 (In Progress): migrate from JibX to JAXB for XML binding / codegen

schema validation behavior

2016-10-12 19:55 - Rob Nahf

Status: New Start date: 2016-10-12

Priority: Normal Due date:  

Assignee: Rob Nahf % Done: 0%

Category: d1_common_java Estimated time: 0.00 hour

Target version:    

Milestone: None Story Points:  

Product Version: *   

Description

unmarshalling objects using JAXB (without schema validation) can lead to changes in the values.  For example, an invalid date

leaves the corresponding Date property as null, instead of throwing an exception.  I don't know what JiBX did in this situation.

Duplicate "identifier" fields in the systemMetadata, for example, doesn't cause problems - one of the identifier values is simply

ignored.

Is this ok, or should we be schema validating when we unmarshal?  How much did JiBX catch and alert us to in the past?  there were

no unit tests dedicated to this issue.

History

#1 - 2018-01-17 23:21 - Rob Nahf

TypeMarshaller currently validates upon marshalling (by default - there's a property setting to control this) but not on unmarshalling.  validation on

marshalling was added to mimic the JiBX behavior.  

TypeMarshaller is the place to add it.  This looks like a decent how-to:  https://docs.oracle.com/cd/E19575-01/819-3669/bnbbc/index.html

#2 - 2018-01-17 23:22 - Rob Nahf

Consider putting this in 2.4.0 to simplify changing dependencies.

#3 - 2018-01-18 02:37 - Dave Vieglais

- Assignee changed from Robert Waltz to Rob Nahf

#4 - 2018-01-18 02:41 - Dave Vieglais

- Sprint set to CCI-2.4.0
